#ifndef RESOURCEMANAGER_INCLUDED
 #define RESOURCEMANAGER_INCLUDED

#include "model.h"
#include <vector>
#include <allegro.h>

class ResourceManager
{
	private:
		std::vector <int> textureIds;
		std::vector <Model> models;
		std::vector <SAMPLE *> samples;
		FONT * mainfont;
	public:
		enum Texture {
			StarTexture = 1,
			BackgroundTexture,
			PointerTexture,
			StarSurfaceTexture,
			GlowTexture,
			ShipTexture,
			TractorTexture,
			MaxTexture
		};
		enum ModelType {
			Empty = 1,
			Ship,
			MaxModel
		};
		
		enum SampleType {
			NotUsedSample = 1,
			MaxSample
		};
	
		
		ResourceManager();
		void loadAll();
		
		int getTexture(Texture which)
		{
			return textureIds[(int) which];
		}
		
		SAMPLE * getSample(SampleType which) {
			return samples[which];
		}
		
		const Model & getModel(ModelType which)
		{
			return models[which];
		}
		
		FONT * getFont() {
			if (mainfont == 0) {
				return font;
			} else {
				return mainfont;
			}
		}
};

extern ResourceManager resourceManager;

#endif // RESOURCEMANAGER_INCLUDED

